{
  description = "System configuration for zion";

  inputs = {
    nixpkgs.url = "nixpkgs/nixos-unstable";
    agenix.url = "github:ryantm/agenix";
    agenix.inputs.nixpkgs.follows = "nixpkgs";
  };

  outputs = { self, nixpkgs, agenix, ... }@inputs:
    let
      system = "aarch64-linux";

      pkgs = import pkgs {
        inherit system;
      };

      lib = nixpkgs.lib;

    in {
      nixosConfigurations.zion = lib.nixosSystem {
        inherit system;
        modules = [ (import ./configuration.nix) agenix.nixosModules.age ];
        specialArgs = { inherit inputs; };
      };

    };
}
